import cgi, os, os.path
from b0lib import AspnDate, render, blogroll, paths

def RenderSinglePost( post ):
	print '<h3 class="postTitle"><a name="%s" href="%s">%s</a></h3>' % ( post.GetAnchor(), post.GetUrl(), post["title"] )
	print '<div>'
	print post.Render()
	print '</div>'
	print ( '''<p class="commentLine"><a href="''' + post.GetFullCommentUrl() + '''" onclick="window.open( this.href, 'comments', 'width=515, height=480, location=0, resizable=1, scrollbars=1, status=0, toolbar=0, directories=0'); return(false);" title="Click here to comment on this post." class="commentLink">Comment on this post</a> [<script type="text/javascript" language="JavaScript">commentCounter( ''' + post.GetId() + ''' )</script> so far]''' )
	post.UpdateRemotePings()
	for topics, topictag in ((post.GetLocalTopics(), 'more like this'),
				 (post.GetITETopics(), 'topic exchange'),
				 ):
		if topics:
			topic_html = []
			for topic,topicurl in topics:
				topic_html.append('<a href="%s">%s</a>' % (topicurl, topic))
			print ' ... %s: [%s]' % (topictag, ', '.join(topic_html))
	print "</p>"

def RenderDayOfPosts( day, maxPosts=-1 ):
	"Prints out a calendar day of posts (up to a max number of maxPosts) and returns the number of posts printed"
	print '''		<div class="bigBox">
			<h2 class="dayTitle">''' + '<a href="%s">%d-%d-%d</a>' % (
		day.GetUrl(),
		day.month.year.number,
		day.month.number,
		day.number
	) + '''</h2>'''
	
	nPosts = 0
	post = day.GetLastPost()
	while post:
		RenderSinglePost( post )
		post = post.GetPrevPost()
		if maxPosts != -1 and nPosts >= maxPosts:
			raise render.DoneEnoughPosts()
		nPosts += 1
	print '''		</div>
'''
	return nPosts

def RenderCalendarDay( dayno, day=None ):
	"Render calendar link for a single day"
	s = "%d" % ( dayno, )
	if day:
		s = '<a href="%s">%s</a>' % ( day.GetUrl(), s )
	print s

def RenderCalendarMonthLink( day ):
	month = day.month
	print '[ <b><a href="%s">%s</a></b> ]' % ( day.GetUrl(), AspnDate.Date.Months[ month.number - 1 ][:3] )

def RenderCalendar( month ):
	if not month: return
	prevMonth = month.GetPrevMonthWrapped()
	nextMonth = month.GetNextMonthWrapped()
	day = month.GetFirstDay()
	print '<div class="thinBorder">'
	print '<table class="calendar">'
	print '<tr><td>Sun</td><td>Mon</td><td>Tue</td><td>Wed</td><td>Thu</td><td>Fri</td><td>Sat</td></tr>'
	print '<tr>'
	daysInMonth = AspnDate.NumberDaysMonth( month.number, month.year.number )
	d = AspnDate.Date( ( month.year.number, month.number, 1 ) )
	#print "%d days in month, starts with %s (day #%d)" % ( daysInMonth, d, d.weekday() )
	if d.weekday() != 6:
		for i in range( 1, d.weekday() + 2 ):
			print "<td></td>"
	while d.month == month.number:
		print "<td>"
		if day and day.number == d.day:
			RenderCalendarDay( d.day, day )
			day = day.GetNextDay()
		else:
			RenderCalendarDay( d.day, None )
		print "</td>"
		if d.weekday() == 5:
			print "</tr><tr>"
		d.next()
	print '</tr>'
	print '</table>'
	print '<p>'
	if prevMonth: RenderCalendarMonthLink( prevMonth.GetLastDay() )
	if nextMonth: RenderCalendarMonthLink( nextMonth.GetFirstDay() )
	print '</p>'
	print '</div>'

execfile( os.path.join( paths.USERCONFPATH(), 'blogroll.py' ) )

# Header
print '''<html>
	<head>
		<title>''' + blog.GetTitle() + '''</title>
		<meta name="Description" content="''' + cgi.escape( blog.GetDescription(), 1 ) + '''" />
		<meta name="DC.title" content="''' + cgi.escape( blog.GetTitle(), 1 ) + '''" />'''

extrapath = os.path.join( paths.USERCONFPATH(), 'extraheaders.html' )
if os.path.isfile( extrapath ):
	print open( extrapath ).read()

print '''		<link rel="alternate" type="application/rss+xml" title="RSS" href="''' + blog.GetUrl() + '''rss.xml" />
		<style type="text/css"><!--
		body {
			font-family: Georgia, "Times New Roman", Times, serif;
		}
		div {
			text-align: left;
		}
		.bigBox {
			padding: 10px;
			margin-bottom: 1em;
		}
		h1, h2, h3 {
			font-family: Verdana, sans-serif;
		}
		#menu {
			float: left;
			width: 200px;
		}
		#main {
			margin-left: 200px;
		}
		head:first-child+body #main { /* for Mozilla */
			margin-left: 200px;
		}
		h1 {
			background-color: lightgreen;
			text-align: center;
			border: solid;
			border-color: green;
			padding: 0.25em;
		}
		h3 {
			margin-top: 0px;
			padding: 2px;
			border: dashed;
			border-color: green;
			border-width: 1px;
			background-color: #f0fff0;
		}
		.smallColumn, .smallNotes {
			font-size: 0.75em;
			font-family: Arial, sans-serif;
		}
		.smallColumn {
			padding: 0.5em;
		}
		.smallNotes {
			text-align: center;
		}
		h2.dayTitle, h2.dayTitle a, h3.postTitle, h3.postTitle a {
			color: black;
		}
		h2.dayTitle {
			margin-top: 0px;
		}
		.thinBorder {
			border: solid;
			border-width: 1px;
			border-color: black;
			padding: 0.5em;
			margin-bottom: 1em;
		}
		.margins {
			margin-left: 10%;
			margin-right: 10%;
		}
		.calendar tr td {
			font-size: 0.75em;
			text-align: center;
		}
		.commentLine {
			font-size: 0.75em;
		}
		// --></style>
	</head>
	<body>
		<h1>''' + '<a style="text-decoration: none; color: black;" href="%s">%s</a>' % ( blog.GetUrl(), blog.GetTitle() ) + '''</h1>

                <div class="smallNotes" style="margin-bottom: 1em;">

                        <p style="margin-top: 0;">''' + blog.GetDescription() + '''</p>
		</div>
		
		<div id="menu">
		<table><tr><td class="smallColumn">
			<!-- left bar -->
			'''
if blog.HasSearch():
	search_url, qs = blog.SearchUrl().split('?', 1)
	qs = qs.split('&')
	print '''
	<div class="thinBorder">
	search:
	<form method="GET" action="%s">
	''' % cgi.escape(search_url)
	for q in qs:
		k,v = q.split('=', 1)
		print '<input type="hidden" name="%s" value="%s" />' % (k,v)
	print '''
	<input type="text" name="q" size="20" />
	<input type="submit" value="Search" />
	</form>
	</div>
	'''
			
if archiveDay:
	RenderCalendar( archiveDay.month )
else:
	RenderCalendar( blog.GetThisMonth() )

blogroll.RenderBlogroll( _blogroll )

print '''
			<div class="thinBorder">
			<a href="''' + blog.GetMailtoUrl() + '''?usernum=''' + '%07d' % ( int( blog.GetUsernum() ), ) + '''">mail the editor</a>
			</div>
			
			<div class="thinBorder">
			also available in <a href="''' + blog.GetUrl() + '''rss.xml"><img border="0" src="http://www.myelin.co.nz/images/xml.gif" width="36" height="14" alt="XML" /></a>
			</div>
			
			<div class="thinBorder">
			Copyright (c) ''' + `blog.GetThisYear().number` + ' ' + cgi.escape( blog.GetAuthor() ) + '''
			</div>

			<div class="thinBorder">
			powered by <i><a href="http://www.myelin.co.nz/bzero/">bzero</a></i>
			</div>

		</td></tr></table>
		</div>

		<div id="main">
			<!-- center bar -->
'''

print (
	'<script src="' + blog.GetCommentsUrl() + '?u=' + blog.GetUsernum()
	+ '''&c=counts" type="text/javascript"></script>'''
	)

if archiveDay:
	RenderDayOfPosts( archiveDay )	
else:
	render.RenderPostList( blog, 10, RenderDayOfPosts )

# Footer
extrapath = os.path.join( paths.USERCONFPATH(), 'extrabase.html' )
if os.path.isfile( extrapath ):
	print open( extrapath ).read()

print '''
	</div>
		<script language="JavaScript" type="text/javascript"><!--
			var imageUrl = "''' + blog.GetWebBugUrl() + '''";
			var imageTag = '<img src="' + imageUrl + "?group=default&usernum=''' + blog.GetUsernum() + '''&referer=" + escape (document.referrer) + '" height="1" width="1">';
			document.write (imageTag);
			//--></script>
	</body>
</html>
'''

